%define _version	2008-05-R1

## some local macros...
%define username	_kismet
%define crontabdir	%_sysconfdir/cron.daily
%define kismethomedir		%_localstatedir/%name
%define kismetlogdir		%_logdir/%name
%define cfgdir		%_sysconfdir/%name
%define _rpmversion	%(echo %_version | tr - .)

Name: kismet
Version: %_rpmversion
Release: alt2
License: GPL
Group: Security/Networking
Url: http://www.kismetwireless.net/
Summary: Kismet wireless tools
Packager: Ilya Mashkin <oddity@altlinux.ru>

Source0: http://www.kismetwireless.net/code/%name-%_version.tar.gz
Source10: stmpclean.kismet
Source11: sysconfig.kismet
Source12: kismet.init

BuildRequires: libexpat-devel libncurses-devel perl-libwww
BuildRequires: libgmp-devel glib-devel fontconfig-devel zlib-devel
BuildRequires: libImageMagick-devel libpcap-devel liblcms-devel
BuildRequires: libtiff-devel libjpeg-devel libfreetype-devel
BuildRequires: bzip2-devel libstdc++-devel gcc-c++ glibc-kernheaders
BuildRequires: libX11-devel libXt-devel libXext-devel
BuildRequires: libdbus-devel liblqr-devel

Requires: kismet-client = %version-%release
Requires: kismet-server = %version-%release
Requires: kismet-drone = %version-%release
Requires: gpsmap = %version-%release

%description
Kismet is an 802.11 layer2 wireless network detector, sniffer, and
intrusion detection system. Kismet will work with any wireless card
which supports raw monitoring (rfmon) mode, and can sniff 802.11b,
802.11a, and 802.11g traffic.

Kismet identifies networks by passively collecting packets and detecting
standard named networks, detecting (and given time, decloaking) hidden
networks, and infering the presence of nonbeaconing networks via data
traffic.

This package is a virtual package requiring all the kismet files to be
installed. You may want to install it in the first time using kismet.

%package common
Summary: Common files for both client/server of kismet
Group: Security/Networking

%description common
Kismet is an 802.11 layer2 wireless network detector, sniffer, and
intrusion detection system. Kismet will work with any wireless card
which supports raw monitoring (rfmon) mode, and can sniff 802.11b,
802.11a, and 802.11g traffic.

This package contains common files for client/server of kismet.

%package client
Summary: Client user interface for kismet
Group: Security/Networking
Requires: kismet-common = %version-%release

%description client
Kismet is an 802.11 layer2 wireless network detector, sniffer, and
intrusion detection system. Kismet will work with any wireless card
which supports raw monitoring (rfmon) mode, and can sniff 802.11b,
802.11a, and 802.11g traffic.

This package contains user interface for kismet.

%package server
Summary: Server side of kismet project
Group: Security/Networking
Requires: kismet-common = %version-%release

%description server
Kismet is an 802.11 layer2 wireless network detector, sniffer, and
intrusion detection system. Kismet will work with any wireless card
which supports raw monitoring (rfmon) mode, and can sniff 802.11b,
802.11a, and 802.11g traffic.

This package contains server side of kismet project.

%package drone
Summary: Drone part of kismet project
Group: Security/Networking

%description drone
Kismet is an 802.11 layer2 wireless network detector, sniffer, and
intrusion detection system. Kismet will work with any wireless card
which supports raw monitoring (rfmon) mode, and can sniff 802.11b,
802.11a, and 802.11g traffic.

This package contains dron part of kismet project.

%package -n gpsmap
Summary: Tool for drawing networks overlaid on downloaded maps
Group: Security/Networking

%description -n gpsmap
A tool for drawing networks overlaid on downloaded maps.
Gpsmap reads the netxml and gpsxml files, sanitizes the data.

GPSMap can download maps from several online sources (MapBlast, Tiger,
Terraserver, Earthamaps, and more) as well as use user-provided graphics,
provided you know the scale and center coordinates.

Main features:
 * Travel path/track
 * Approximate network circular range
 * Approximate network center
 * Convex hull of all network sample points
 * Interpolated (weathermap-style) graphing of power and range
 * Labeling of network centers
 * Scatterplot of all detected packets
 * Legend showing total sample networks, visible networks, colors,
   power ranges, network center, etc.

%prep
%setup -q -n %name-%_version

sed -e 's!/var/log/kismet!%kismetlogdir!g' %SOURCE10 >stmpclean.kismet
touch --reference=%SOURCE10 stmpclean.kismet || :	# keep timestamp

# set our 'kismet' user, disable GPS and log into %%kismetlogdir by
# default
sed -i -e "s!your_user_here!%username!g;
           s!^gps=true!gps=false!;
           s!^logtemplate=%%!logtemplate=%kismetlogdir/%%!;
	   s!^configdir=.*!configdir=%kismethomedir/!;
	   s!^piddir=.*!piddir=/var/run/kismet/!" \
		conf/kismet.conf.in conf/kismet_drone.conf

# do not strip installed binaries as it conflicts with the -debuginfo
# mechanism
sed -i -e "s!\(install .*\) -s !\1 !g" Makefile.in

%build
export ac_cv_header_linux_netlink_h=yes	# we have netlink.h; just the check is buggy
export ac_cv_lib_uClibcpp_main=no	# we do not want to build against uClibc++, even when available

%configure \
	--enable-ipv6 \
	--sysconfdir=%cfgdir \
	--enable-syspcap

%make_build

%install
make install \
	DESTDIR=%buildroot \
	INSTUSR="$(id -un)" INSTGRP="$(id -gn)" MANGRP="$(id -gn)"
install -d %buildroot{%kismethomedir,%kismetlogdir,%crontabdir,%_sysconfdir/sysconfig}
install -p -m755 stmpclean.kismet %buildroot%crontabdir/kismet
install -p -m644 %SOURCE11 %buildroot%_sysconfdir/sysconfig/kismet

#docs
mkdir -p %buildroot%_datadir/doc/%name-%version
gzip CHANGELOG
gzip CHANGELOG-OLD
cp -R CHANGELOG* README TODO extra/*.sh extra/*.pl docs \
	%buildroot%_datadir/doc/%name-%version/

# wrapper to launch kismet on NON-ALT systems goes to /dev/null
rm -f %buildroot%_bindir/kismet

install -pD -m755 %SOURCE12 %buildroot%_initdir/kismet

mkdir -p %buildroot%_var/run/%name

%pre common
%_sbindir/groupadd -r -f %username &>/dev/null
%_sbindir/useradd -r -g %username -d %_datadir/%name -s /dev/null \
        -c "kismet pseudouser" -M -n %username &>/dev/null ||:

%post server
%post_service %name

%preun server
%preun_service %name

%files

%files common
%dir %attr(0770,root,%username) %kismethomedir
%dir %attr(0730,root,%username) %kismetlogdir
%dir %attr(0751,root,%username) %cfgdir
%dir %attr(0770,%username,%username) %_var/run/%name
%cfgdir/*_manuf
%config            %crontabdir/kismet
%config(noreplace) %_sysconfdir/sysconfig/kismet
%_datadir/kismet
%_man1dir/kismet.1*
%_datadir/doc/%name-%version

%files client
%_bindir/kismet_client
%_man5dir/kismet_ui.conf*
%config(noreplace) %cfgdir/kismet_ui.conf

%files server
%_bindir/kismet_server
%_man5dir/kismet.conf*
%config(noreplace) %cfgdir/kismet.conf
%_initdir/%name

%files drone
%_bindir/kismet_drone
%_man1dir/kismet_drone*
%_man5dir/kismet_drone*
%config(noreplace) %cfgdir/kismet_drone.conf

%files -n gpsmap
%_bindir/gps*
%_mandir/*/gps*

%changelog
* Sat Feb 21 2009 Ilya Mashkin <oddity@altlinux.ru> 2008.05.R1-alt2
- fix build
- update requires (fix #18831)
- fix init script (fix #18832)

* Mon Jun 02 2008 Pavlov Konstantin <thresh@altlinux.ru> 2008.05.R1-alt1
- 2008-05-R1 release.

* Fri Oct 19 2007 Pavlov Konstantin <thresh@altlinux.ru> 2007.10.R1-alt1
- 2007.10.R1 version.

* Sun Jan 21 2007 Pavlov Konstantin <thresh@altlinux.ru> 2007.01.R1b-alt4
- Added fix for enable building on x86_64.

* Sun Jan 21 2007 Pavlov Konstantin <thresh@altlinux.ru> 2007.01.R1b-alt3
- Specfile fixes here and there.
- Removed wget and diffutils from build requres.
- Replaced linux-libc-headers with glibc-kernheaders.
- Introduced gpsmap package.
- Packed some scripts from extra/ to kismet-common package.

* Sat Jan 20 2007 Pavlov Konstantin <thresh@altlinux.ru> 2007.01.R1b-alt2
- Added daemonization patch.
- Fixed kismet init script to work with daemonization.

* Sat Jan 20 2007 Pavlov Konstantin <thresh@altlinux.ru> 2007.01.R1b-alt1
- 2007-01-R1b version.

* Sat Jan 20 2007 Pavlov Konstantin <thresh@altlinux.ru> 2006.04.R1-alt2
- Merged patches into source tree.
- Removed unneeded SOURCE1.

* Fri Nov 17 2006 Pavlov Konstantin <thresh@altlinux.ru> 2006.04.R1-alt1
- Added init-script.
- Changed pid dir.
- Removed *.conf files from common package.

* Mon Aug 28 2006 Pavlov Konstantin <thresh@altlinux.ru> 2006.04.R1-alt0.2
- Initial packaging for ALT Linux.
- main package is virtual, that requires:
  + kismet-server, the server side of kismet.
  + kismet-client, the client user interface of kismet.
  + kismet-drone, the remote drone for kismet.
- The spec file is based on Mandriva/FC's one, good man who made it is
  + Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>

